blob: 0723f6935da49bcb859bc9e748c97e315b713f09 [file] [log] [blame]
Josh Coalsonbb7f6b92000-12-10 04:09:52 +00001#!/bin/sh
2
Josh Coalson6b05bc52001-06-08 00:13:21 +00003# FLAC - Free Lossless Audio Codec
Josh Coalson1152f9f2002-01-26 18:05:12 +00004# Copyright (C) 2001,2002 Josh Coalson
Josh Coalson6b05bc52001-06-08 00:13:21 +00005#
6# This program is part of FLAC; you can redistribute it and/or
7# modify it under the terms of the GNU General Public License
8# as published by the Free Software Foundation; either version 2
9# of the License, or (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program; if not, write to the Free Software
18# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19
Josh Coalson67fcd8e2001-01-19 23:10:56 +000020LD_LIBRARY_PATH=../src/libFLAC/.libs:../obj/lib:$LD_LIBRARY_PATH
Josh Coalsonbb7f6b92000-12-10 04:09:52 +000021export LD_LIBRARY_PATH
Josh Coalson67fcd8e2001-01-19 23:10:56 +000022PATH=../src/flac:../src/test_streams:../obj/bin:$PATH
Josh Coalsonbb7f6b92000-12-10 04:09:52 +000023
Josh Coalsonbc15aee2002-06-15 05:12:31 +000024flac --help 1>/dev/null 2>/dev/null || (echo "ERROR can't find flac executable" 1>&2 && exit 1)
25if [ $? != 0 ] ; then exit 1 ; fi
Josh Coalsonbc869502002-06-14 06:36:16 +000026
Josh Coalsonf6237c82001-02-28 23:43:29 +000027echo "Generating streams..."
Josh Coalson67fcd8e2001-01-19 23:10:56 +000028if test_streams ; then : ; else
Josh Coalsonbb7f6b92000-12-10 04:09:52 +000029 echo "ERROR during test_streams" 1>&2
30 exit 1
31fi
32
Josh Coalson9bcf9e82002-08-07 17:07:37 +000033echo "Checking for --ogg support in flac..."
34if flac --ogg wacky1.wav 1>/dev/null 2>&1 ; then
35 has_ogg=yes;
36 echo "flac --ogg works"
37else
38 has_ogg=no;
39 echo "flac --ogg doesn't work"
40fi
41
42#
43# multi-file tests
44#
45echo "Generating multiple input files from noise..."
Josh Coalsoneb209032002-08-20 20:37:26 +000046if flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=16 --channels=2 noise.raw ; then : ; else
Josh Coalson9bcf9e82002-08-07 17:07:37 +000047 echo "ERROR generating FLAC file" 1>&2
48 exit 1
49fi
Josh Coalson6a8ff472002-08-12 20:26:22 +000050if flac --decode --silent noise.flac ; then : ; else
Josh Coalson9bcf9e82002-08-07 17:07:37 +000051 echo "ERROR generating WAVE file" 1>&2
52 exit 1
53fi
54rm -f noise.flac
Josh Coalson76e87252002-08-08 22:54:03 +000055mv noise.wav file0.wav
56cp file0.wav file1.wav
57cp file1.wav file2.wav
Josh Coalson9bcf9e82002-08-07 17:07:37 +000058
59test_multifile ()
60{
61 streamtype=$1
Josh Coalsona1283a22002-08-16 05:36:53 +000062 sector_align=$2
63 encode_options="$3"
Josh Coalson9bcf9e82002-08-07 17:07:37 +000064
65 if [ $streamtype = ogg ] ; then
66 suffix=ogg
67 encode_options="$encode_options --ogg"
68 else
69 suffix=flac
70 fi
71
Josh Coalsona1283a22002-08-16 05:36:53 +000072 if [ $sector_align = sector_align ] ; then
73 encode_options="$encode_options --sector-align"
74 fi
75
Josh Coalson76e87252002-08-08 22:54:03 +000076 if flac $encode_options file0.wav file1.wav file2.wav ; then : ; else
Josh Coalson9bcf9e82002-08-07 17:07:37 +000077 echo "ERROR" 1>&2
78 exit 1
79 fi
80 for n in 0 1 2 ; do
Josh Coalson76e87252002-08-08 22:54:03 +000081 mv file$n.$suffix file${n}x.$suffix
Josh Coalson9bcf9e82002-08-07 17:07:37 +000082 done
Josh Coalson6a8ff472002-08-12 20:26:22 +000083 if flac --decode file0x.$suffix file1x.$suffix file2x.$suffix ; then : ; else
Josh Coalson9bcf9e82002-08-07 17:07:37 +000084 echo "ERROR" 1>&2
85 exit 1
86 fi
Josh Coalsona1283a22002-08-16 05:36:53 +000087 if [ $sector_align != sector_align ] ; then
88 for n in 0 1 2 ; do
89 if cmp file$n.wav file${n}x.wav ; then : ; else
90 echo "ERROR: file mismatch on file #$n" 1>&2
91 exit 1
92 fi
93 done
94 fi
Josh Coalson9bcf9e82002-08-07 17:07:37 +000095 for n in 0 1 2 ; do
Josh Coalson76e87252002-08-08 22:54:03 +000096 rm -f file${n}x.$suffix file${n}x.wav
Josh Coalson9bcf9e82002-08-07 17:07:37 +000097 done
98}
99
100echo "Testing multiple files without verify..."
Josh Coalsona1283a22002-08-16 05:36:53 +0000101test_multifile flac no_sector_align ""
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000102
103echo "Testing multiple files with verify..."
Josh Coalsona1283a22002-08-16 05:36:53 +0000104test_multifile flac no_sector_align "--verify"
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000105
Josh Coalsona1283a22002-08-16 05:36:53 +0000106echo "Testing multiple files with --sector-align, without verify..."
107test_multifile flac sector_align ""
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000108
Josh Coalsona1283a22002-08-16 05:36:53 +0000109echo "Testing multiple files with --sector-align, with verify..."
110test_multifile flac sector_align "--verify"
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000111
112if [ $has_ogg = "yes" ] ; then
113 echo "Testing multiple files with --ogg, without verify..."
Josh Coalsona1283a22002-08-16 05:36:53 +0000114 test_multifile ogg no_sector_align ""
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000115
116 echo "Testing multiple files with --ogg, with verify..."
Josh Coalsona1283a22002-08-16 05:36:53 +0000117 test_multifile ogg no_sector_align "--verify"
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000118
Josh Coalsona1283a22002-08-16 05:36:53 +0000119 echo "Testing multiple files with --ogg and --sector-align, without verify..."
120 test_multifile ogg sector_align ""
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000121
Josh Coalsona1283a22002-08-16 05:36:53 +0000122 echo "Testing multiple files with --ogg and --sector-align, with verify..."
123 test_multifile sector_align ogg "--verify"
Josh Coalson07414eb2002-09-04 07:56:02 +0000124
125 echo "Testing multiple files with --ogg and --serial-number, with verify..."
126 test_multifile ogg no_sector_align "--serial-number=321 --verify"
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000127fi
128
Josh Coalson9bcf9e82002-08-07 17:07:37 +0000129#
130# single-file tests
131#
132
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000133test_file ()
134{
135 name=$1
136 channels=$2
137 bps=$3
138 encode_options="$4"
139
Josh Coalson9b145182002-08-30 05:39:36 +0000140 echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
Josh Coalsoneb209032002-08-20 20:37:26 +0000141 cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.raw"
Josh Coalson29b4af82001-02-08 22:00:05 +0000142 echo "### ENCODE $name #######################################################" >> ./streams.log
143 echo "### cmd=$cmd" >> ./streams.log
Josh Coalsoncc78fb52001-05-03 00:59:27 +0000144 if $cmd 2>>./streams.log ; then : ; else
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000145 echo "ERROR during encode of $name" 1>&2
146 exit 1
147 fi
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000148 echo -n "decode..."
Josh Coalson5f39e9f2002-08-21 05:27:01 +0000149 cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --output-name=$name.cmp $name.flac"
Josh Coalson29b4af82001-02-08 22:00:05 +0000150 echo "### DECODE $name #######################################################" >> ./streams.log
151 echo "### cmd=$cmd" >> ./streams.log
Josh Coalson970cd3d2001-07-09 18:15:36 +0000152 if $cmd 2>>./streams.log ; then : ; else
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000153 echo "ERROR during decode of $name" 1>&2
154 exit 1
155 fi
Josh Coalson29b4af82001-02-08 22:00:05 +0000156 ls -1l $name.raw >> ./streams.log
157 ls -1l $name.flac >> ./streams.log
158 ls -1l $name.cmp >> ./streams.log
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000159 echo -n "compare..."
160 if cmp $name.raw $name.cmp ; then : ; else
161 echo "ERROR during compare of $name" 1>&2
162 exit 1
163 fi
164 echo OK
165}
166
Josh Coalsona59ff6f2002-06-10 18:24:51 +0000167test_file_piped ()
168{
169 name=$1
170 channels=$2
171 bps=$3
172 encode_options="$4"
173
Josh Coalsond57c8d32002-06-11 06:15:28 +0000174 if [ `env | grep -ic '^comspec='` != 0 ] ; then
175 is_win=yes
176 else
177 is_win=no
178 fi
179
Josh Coalsona59ff6f2002-06-10 18:24:51 +0000180 echo -n "$name: encode via pipes..."
Josh Coalsond57c8d32002-06-11 06:15:28 +0000181 if [ $is_win = yes ] ; then
Josh Coalsoneb209032002-08-20 20:37:26 +0000182 cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout $name.raw"
Josh Coalsond57c8d32002-06-11 06:15:28 +0000183 echo "### ENCODE $name #######################################################" >> ./streams.log
184 echo "### cmd=$cmd" >> ./streams.log
185 if $cmd 1>$name.flac 2>>./streams.log ; then : ; else
186 echo "ERROR during encode of $name" 1>&2
187 exit 1
188 fi
189 else
Josh Coalsoneb209032002-08-20 20:37:26 +0000190 cmd="flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --stdout -"
Josh Coalsond57c8d32002-06-11 06:15:28 +0000191 echo "### ENCODE $name #######################################################" >> ./streams.log
192 echo "### cmd=$cmd" >> ./streams.log
193 if cat $name.raw | $cmd 1>$name.flac 2>>./streams.log ; then : ; else
194 echo "ERROR during encode of $name" 1>&2
195 exit 1
196 fi
Josh Coalsona59ff6f2002-06-10 18:24:51 +0000197 fi
198 echo -n "decode via pipes..."
Josh Coalsond57c8d32002-06-11 06:15:28 +0000199 if [ $is_win = yes ] ; then
Josh Coalson5f39e9f2002-08-21 05:27:01 +0000200 cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --stdout $name.flac"
Josh Coalsond57c8d32002-06-11 06:15:28 +0000201 echo "### DECODE $name #######################################################" >> ./streams.log
202 echo "### cmd=$cmd" >> ./streams.log
203 if $cmd 1>$name.cmp 2>>./streams.log ; then : ; else
204 echo "ERROR during decode of $name" 1>&2
205 exit 1
206 fi
207 else
Josh Coalson5f39e9f2002-08-21 05:27:01 +0000208 cmd="flac --silent --endian=big --sign=signed --decode --force-raw-format --stdout -"
Josh Coalsond57c8d32002-06-11 06:15:28 +0000209 echo "### DECODE $name #######################################################" >> ./streams.log
210 echo "### cmd=$cmd" >> ./streams.log
211 if cat $name.flac | $cmd 1>$name.cmp 2>>./streams.log ; then : ; else
212 echo "ERROR during decode of $name" 1>&2
213 exit 1
214 fi
Josh Coalsona59ff6f2002-06-10 18:24:51 +0000215 fi
216 ls -1l $name.raw >> ./streams.log
217 ls -1l $name.flac >> ./streams.log
218 ls -1l $name.cmp >> ./streams.log
219 echo -n "compare..."
220 if cmp $name.raw $name.cmp ; then : ; else
221 echo "ERROR during compare of $name" 1>&2
222 exit 1
223 fi
224 echo OK
225}
226
Josh Coalson9b145182002-08-30 05:39:36 +0000227if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
228 max_lpc_order=32
229else
230 max_lpc_order=16
231fi
232
Josh Coalsona59ff6f2002-06-10 18:24:51 +0000233echo "Testing noise through pipes..."
234test_file_piped noise 1 8 "-0"
235
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000236echo "Testing small files..."
Josh Coalson9b145182002-08-30 05:39:36 +0000237test_file test01 1 16 "-0 -l $max_lpc_order -m -e -p"
238test_file test02 2 16 "-0 -l $max_lpc_order -m -e -p"
239test_file test03 1 16 "-0 -l $max_lpc_order -m -e -p"
240test_file test04 2 16 "-0 -l $max_lpc_order -m -e -p"
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000241
242echo "Testing 8-bit full-scale deflection streams..."
243for b in 01 02 03 04 05 06 07 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000244 test_file fsd8-$b 1 8 "-0 -l $max_lpc_order -m -e -p"
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000245done
246
247echo "Testing 16-bit full-scale deflection streams..."
248for b in 01 02 03 04 05 06 07 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000249 test_file fsd16-$b 1 16 "-0 -l $max_lpc_order -m -e -p"
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000250done
251
Josh Coalsonf6237c82001-02-28 23:43:29 +0000252echo "Testing 24-bit full-scale deflection streams..."
253for b in 01 02 03 04 05 06 07 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000254 test_file fsd24-$b 1 24 "-0 -l $max_lpc_order -m -e -p"
Josh Coalson29b4af82001-02-08 22:00:05 +0000255done
Josh Coalsonf6237c82001-02-28 23:43:29 +0000256
Josh Coalsond0418492001-03-27 23:58:23 +0000257echo "Testing 16-bit wasted-bits-per-sample streams..."
258for b in 01 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000259 test_file wbps16-$b 1 16 "-0 -l $max_lpc_order -m -e -p"
Josh Coalsond0418492001-03-27 23:58:23 +0000260done
261
Josh Coalson9fb180b2002-08-22 07:26:06 +0000262for bps in 8 16 24 ; do
Josh Coalsonf6237c82001-02-28 23:43:29 +0000263 echo "Testing $bps-bit sine wave streams..."
Josh Coalson9fb180b2002-08-22 07:26:06 +0000264 for b in 00 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000265 test_file sine${bps}-$b 1 $bps "-0 -l $max_lpc_order -m -e --sample-rate=48000"
Josh Coalson9fb180b2002-08-22 07:26:06 +0000266 done
267 for b in 01 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000268 test_file sine${bps}-$b 1 $bps "-0 -l $max_lpc_order -m -e --sample-rate=96000"
Josh Coalson9fb180b2002-08-22 07:26:06 +0000269 done
270 for b in 02 03 04 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000271 test_file sine${bps}-$b 1 $bps "-0 -l $max_lpc_order -m -e"
Josh Coalsonf6237c82001-02-28 23:43:29 +0000272 done
Josh Coalson9fb180b2002-08-22 07:26:06 +0000273 for b in 10 11 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000274 test_file sine${bps}-$b 2 $bps "-0 -l $max_lpc_order -m -e --sample-rate=48000"
Josh Coalson9fb180b2002-08-22 07:26:06 +0000275 done
276 for b in 12 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000277 test_file sine${bps}-$b 2 $bps "-0 -l $max_lpc_order -m -e --sample-rate=96000"
Josh Coalson9fb180b2002-08-22 07:26:06 +0000278 done
279 for b in 13 14 15 16 17 18 19 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000280 test_file sine${bps}-$b 2 $bps "-0 -l $max_lpc_order -m -e"
Josh Coalsonf6237c82001-02-28 23:43:29 +0000281 done
Josh Coalsonbb7f6b92000-12-10 04:09:52 +0000282done
283
284echo "Testing some frame header variations..."
Josh Coalson9b145182002-08-30 05:39:36 +0000285test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax -b $max_lpc_order"
286test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax -b 65535"
287test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=9"
288test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=90"
289test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=90000"
Josh Coalsone2281f32002-09-11 00:31:47 +0000290test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=9"
291test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=90"
292test_file sine16-01 1 16 "-0 -l $max_lpc_order -m -e -p --lax --sample-rate=90000"
Josh Coalson29b4af82001-02-08 22:00:05 +0000293
294echo "Testing option variations..."
295for f in 00 01 02 03 04 ; do
296 for opt in 0 1 2 4 5 6 8 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000297 for extras in '' '-p' '-e' ; do
Josh Coalsonf6237c82001-02-28 23:43:29 +0000298 test_file sine16-$f 1 16 "-$opt $extras"
Josh Coalson29b4af82001-02-08 22:00:05 +0000299 done
300 done
Josh Coalson9b145182002-08-30 05:39:36 +0000301 if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
302 test_file sine16-$f 1 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
303 fi
Josh Coalson29b4af82001-02-08 22:00:05 +0000304done
Josh Coalson9b145182002-08-30 05:39:36 +0000305
Josh Coalson29b4af82001-02-08 22:00:05 +0000306for f in 10 11 12 13 14 15 16 17 18 19 ; do
307 for opt in 0 1 2 4 5 6 8 ; do
Josh Coalson9b145182002-08-30 05:39:36 +0000308 for extras in '' '-p' '-e' ; do
Josh Coalsonf6237c82001-02-28 23:43:29 +0000309 test_file sine16-$f 2 16 "-$opt $extras"
Josh Coalson29b4af82001-02-08 22:00:05 +0000310 done
311 done
Josh Coalson9b145182002-08-30 05:39:36 +0000312 if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
313 test_file sine16-$f 2 16 "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
314 fi
Josh Coalson29b4af82001-02-08 22:00:05 +0000315done
316
317echo "Testing noise..."
Josh Coalson9b145182002-08-30 05:39:36 +0000318for channels in 1 2 4 8 ; do
319 for bps in 8 16 24 ; do
320 for opt in 0 1 2 3 4 5 6 7 8 ; do
321 for extras in '' '-p' '-e' ; do
Josh Coalson214d3192002-08-31 05:47:33 +0000322 for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
Josh Coalsonc5f2f3f2001-02-08 22:21:45 +0000323 test_file noise $channels $bps "-$opt $extras $blocksize"
Josh Coalson29b4af82001-02-08 22:00:05 +0000324 done
325 done
326 done
Josh Coalson9b145182002-08-30 05:39:36 +0000327 if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
328 test_file noise $channels $bps "-b 16384 -m -r 8 -l $max_lpc_order -e -p"
329 fi
Josh Coalson29b4af82001-02-08 22:00:05 +0000330 done
331done